#!ruby -Ks
#
#  TOPPRES/A-CAN
#      Automotive CAN
#
#  Copyright (C) 2013-2015 by Center for Embedded Computing Systems
#                             Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd.
#  Copyright (C) 2013-2015 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2014-2015 by FUJITSU TEN LIMITED.
#  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2013-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2014-2015 by SCSK Corporation
#  Copyright (C) 2013-2015 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2015 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2015 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: get_spec_id.rb 1241 2015-03-25 07:26:02Z panasonic-ayane $
#

#=====================================================================
# ƥȥե(AUTOSAR_SWS_CANDriver_R4.0.3.txt)顤CANIF˴ؤ
# ͥȴФơIDեؽϤ
# ƥȥեϡPDFեAdobe ReaderѴǽѤơ
#   
#=====================================================================

# 񤭽Фե
sWriteFileId = File.dirname(__FILE__) + "/autosar_spec_id.txt"

# pdfɤ߽Фƥȥǡ
sTextFile = "AUTOSAR_SWS_CANDriver_R4.0.3.txt"

# ƥȥեɤ߹
sText = File.read(sTextFile)

# Ԥ(ǲԤ륱б)
sText.gsub!("\r\n", "")
sText.gsub!("\r", "")
sText.gsub!("\n", "")

# оݥ򸡺
aData1 = sText.scan(/\[CAN[0-9][0-9][0-9]\]/) + sText.scan(/CAN[0-9][0-9][0-9]:\s/)
aData2 = sText.scan(/CAN[0-9][0-9][0-9]_Conf\s:/)
nData1 = aData1.size()
nData2 = aData2.size()

# 쥮顼եޥåȤưɲä
aTags = aData1 + aData2 + ["CAN026", "CAN028", "CAN091", "CAN089", "CAN080"]

aData = []
aDup = []

# :,[,]
aTags.each{|sLine|
  sTemp = sLine.gsub(/:|\s|\[|\]/, "")
  # ʣƤΤ2٤ʤ
  if (aData.include?(sTemp))
    aDup.push(sTemp)
  else
    aData.push(sTemp)
  end
}

# IDǥ
aData.sort!

# 1Ĥʸˤ
sOutString = aData.join("\n")

# եؽϤ
File.open(sWriteFileId, "w") {|io|
  io.puts(sOutString)
}

# IDηɽ
print("==============================\n")
printf("CAN***      : %3d\n", nData1)
printf("CAN***_Conf : %3d\n", nData2)
print("==============================\n")
printf("Total       : %3d\n", (nData1 + nData2))

# ʣID¸ߤɽ
if (aDup.size != 0)
  aDup.sort!
  print("--------------------------------\n")
  print("the following IDs are duplicated\n")
  print("--------------------------------\n")
  aDup.each{|sLine|
    print(sLine + "\n")
  }
end
